package paycard;

public class PayCard {

    /*@
      @ public instance invariant log != null;
      @ public instance invariant balance >=0;
      @ public instance invariant limit >0;
      @ public instance invariant unsuccessfulOperations >=0;
      @*/

    /*@ spec_public @*/ int limit=1000;
    /*@ spec_public @*/ int unsuccessfulOperations;
    /*@ spec_public @*/ int id;
    /*@ spec_public @*/ int balance=0;
    /*@ spec_public @*/ protected LogFile log;

    public PayCard(int limit) {
        balance = 0;
        unsuccessfulOperations=0;
        this.limit=limit;
    }

    public PayCard() {
	balance=0;
        unsuccessfulOperations=0;
    }

    /*@
      public normal_behavior
      requires amount>0 ;
      assignable unsuccessfulOperations, balance;
      ensures balance >= \old(balance);
      @*/
    public boolean charge(int amount) {
        if (this.balance+amount>=this.limit) {
            this.unsuccessfulOperations++;
	    return false;
        } else {
            this.balance=this.balance+amount;
	    return true;
        }
    }

    /*@
      public normal_behavior
      requires amount>0;
      assignable unsuccessfulOperations, balance;
      ensures balance >= \old(balance);
      @*/
    public void chargeAndRecord(int amount) {
	if (charge(amount)) {
	    try {
		log.addRecord(balance);
	    } catch (CardException e){
		throw new IllegalStateException();
	    }
	}

    }

    /*@
      public normal_behavior
      requires true;
      ensures \result == balance || unsuccessfulOperations > 3;
      @*/
    public /*@pure@*/ int available() {
	if (unsuccessfulOperations<=3) {
	    return this.balance;
        }
        return 0;
    }

    public String infoCardMsg() {
        return (" Current balance on card is " + balance);
    }
}
